/*
 * HamPostaja1.ino
 *
 * Created: 4/22/2015 10:17:10 PM
 * Author: Marko
 */ 

//#include <LCD5110_Basic/LCD5110_Basic.h>
#include <LCD5110_Graph/LCD5110_Graph.h>
//#include <SoftwareSerial/SoftwareSerial.h>
#include <SPI/SPI.h>
//#include <Adafruit-GFX-Library-master/Adafruit_GFX.h>
//#include <Adafruit-PCD8544-Nokia-5110-LCD-library-master/Adafruit_PCD8544.h>

//Serijski port na VHF
#define Vhf_Tx 11
#define Vhf_Rx 9
#define Vhf_RecAct 10
#define Vhf_GoTx 12



//Serijski port na UHF
//#define Uhf_Tx 11
//#define Uhf_Rx 12



//Priklop enkoderja
#define ENC_A 2			
#define ENC_B 3			
#define ENC_Stk 4

//Debounce time in ms
#define DebTime 35


//Priklop Nokia 5110 LCD
#define LCD_SCK	  A5		//A0
#define LCD_MOSI  A4		//A1
#define LCD_DC    A3		//A2
#define LCD_RST	  A2		//A3
#define LCD_CS	  A1		//A4


LCD5110 MojGLCD(LCD_SCK,LCD_MOSI,LCD_DC,LCD_RST,LCD_CS);
extern uint8_t TinyFont[];
extern uint8_t SmallFont[];
//extern uint8_t MediumNumbers[];
//extern uint8_t BigNumbers[];

//SoftwareSerial Vhf_Port(Vhf_Rx,Vhf_Tx);
//SoftwareSerial Uhf_Port(Uhf_Rx,Uhf_Tx);


// Set parameters for DRA818V
int BW = 0;							// Bandwith in KHz (0 = 12.5KHz or 1 = 25KHz)
long int FrekvMode = 4334000;       // TX frequency in MHz (134.0000 - 174.0000) for frequency mode
double FTx = 433.4000;				// TX frequency in MHz (134.0000 - 174.0000)
double FRx = 433.4000;				// RX frequency in MHz (134.0000 - 174.0000)
String tx_ctcss = "0000";			// CTCSS frequency (0000 - 0038); 0000 = "no CTCSS"
String rx_ctcss = "0000";			// CTCSS frequency (0000 - 0038); 0000 = "no CTCSS"
int squ = 4;						// Squelch level (0 - 8); 0 = "open"

int vol = 8;						//Nastavitev glasnosti modula (0-8)
byte ModeDela = 1;					//1 - Memory mode, 2 - Frequency mode

//String txtOdgovor = "";
String MemOpis = " ";
byte znaki = 0;
long int urica = 0;
int EnkTmp = 0;
byte Spomini = 4;
byte tmpSql = 0;
byte Podrocje = 2;					//1 - VHF, 2 - UHF
volatile byte eDir = 0;
byte Izpisi = 0;
byte OldIzpisi = 0;


//definicija procedur in funkcij
void BeriIzSpomina();
void BeriIzSpomina_UHF();
void BeriIzSpomina_VHF();
void Nastavi_DRA();
void Nastavi_Vol_DRA();
void OsnovniZaslon();
void ZbrisiPodrocje(byte x1, byte y1, byte x2, byte y2);
void Nastavitve();
void Preberi_Enkoder_1();
void PrikaziIzbiroModa();
void PrikaziIzbiroVU();
void NastaviGlasnost();
void NastaviSquelch();
void NastaviVU();
void NastaviMode();



void setup()
{

	/* add setup code here, setup code runs once when the processor starts */
	pinMode(ENC_A,INPUT_PULLUP);
	pinMode(ENC_B,INPUT_PULLUP);
	pinMode(ENC_Stk,INPUT_PULLUP);	 
	pinMode(Vhf_RecAct,INPUT_PULLUP); 
	pinMode(Vhf_GoTx,INPUT_PULLUP);
	
	MojGLCD.InitLCD();
	MojGLCD.setFont(SmallFont);
	MojGLCD.drawRoundRect(0,0,83,47);
	MojGLCD.print("VHF/UHF",CENTER,2);
	MojGLCD.update();
	delay(500);
	MojGLCD.print("Amateur",CENTER,10);
	MojGLCD.update();
	delay(500);
	MojGLCD.print("Radio",CENTER,18);
	MojGLCD.update();
	delay(500);
	MojGLCD.print("by",CENTER,26);
	MojGLCD.update();
	delay(500);
	MojGLCD.print("S56FGS",CENTER,38);
	MojGLCD.update();
	delay(500);
	MojGLCD.clrScr();
	MojGLCD.update();

	Serial.begin(9600);
	
	attachInterrupt(0,Preberi_Enkoder_1,FALLING);
	
	OsnovniZaslon();

	// DRA818V
	BeriIzSpomina_UHF();
	Nastavi_Vol_DRA();	
}

void loop()
{
	
	/* add main program code here, this code starts again each time it ends */
/*   if ((millis()-urica) > 999)
   {
		   urica = millis();
		   digitalWrite(13,HIGH);
		   delay(3);
		   digitalWrite(13,LOW);
		   //Serial.println("AT+DMOCONNECT");
	}*/
	
	if (eDir == 1)
	{
		if (ModeDela == 1)						//Spominski nain dela
		{
			Spomini++;
			if (Podrocje == 1)
			{
				if (Spomini > 56)
				{
					Spomini = 1;
				}
			} 
			else
			{
				if (Spomini > 30)
				{
					Spomini = 1;
				}
			}
			BeriIzSpomina();			
		} 
		else
		{
			FrekvMode = FrekvMode + 125;
			if (Podrocje == 1)					//VHF
			{
				if (FrekvMode > 1460000)
				{
					FrekvMode = 1460000;
				}
			} 
			else								//UHF
			{
				if (FrekvMode > 4340000)
				{
					FrekvMode = 4340000;
				}
			}
			FTx = (float)FrekvMode / 10000;
			FRx = FTx;
			Nastavi_DRA();
		}
		eDir = 0;
	}
	if (eDir == 2)
	{
		if (ModeDela == 1)						// Spominski nain dela
		{
			Spomini--;
			if (Podrocje == 1)
			{
				if (Spomini < 1)
				{
					Spomini = 56;
				}
			} 
			else
			{
				if (Spomini < 1)
				{
					Spomini = 30;
				}
			}
			BeriIzSpomina();
		} 
		else
		{
			FrekvMode = FrekvMode - 125;
			if (Podrocje == 1)					//VHF
			{
				if (FrekvMode < 1440000)
				{
					FrekvMode = 1440000;
				}
			} 
			else								//UHF
			{
				if (FrekvMode < 4320000)
				{
					FrekvMode = 4320000;
				}
			}
			FTx = (float)FrekvMode / 10000;
			FRx = FTx;
			Nastavi_DRA();
		}
		eDir = 0;
	}
	//Tipka na enkoderju
	if (digitalRead(ENC_Stk) == LOW)
	{
		delay(DebTime);
		if (digitalRead(ENC_Stk) == LOW)
		{
			delay(DebTime);
			urica = millis();
			znaki = true;
			do
			{
				//poakam, da model spusti tipko
				if ((millis()-urica) > 200)
				{
					if (znaki == true)
					{
						tmpSql = squ;
						squ = 0;
						FRx = FTx;
						Nastavi_DRA();
						squ = tmpSql;
						znaki = false;
					}
				}
			} while (digitalRead(ENC_Stk) == LOW);
			// e je kratek pritisk gremo v nastavitve
			if ((millis()-urica) < 200)
			{
				if (ModeDela == 1)
				{
					BeriIzSpomina();					
				}
				else
				{
					Nastavi_DRA();
				}
				Nastavitve();
			}
			if (ModeDela == 1)
			{
				BeriIzSpomina();				
			}
			else
			{
				tx_ctcss = "0000";
				rx_ctcss = "0000";
				FTx = (float)FrekvMode / 10000;				// TX frequency in MHz (134.0000 - 174.0000)
				FRx = FTx;									// RX frequency in MHz (134.0000 - 174.0000)
				Nastavi_DRA();
			}
		}
	}
	
	if (digitalRead(Vhf_RecAct) == LOW)
	{
		//MojGLCD.print("RX",CENTER,2);
		//MojGLCD.printNumF(FRx,4,17,26);
		//MojGLCD.update();
		Izpisi = 1;
	} 
	else if(digitalRead(Vhf_GoTx) == LOW)
	{
		//MojGLCD.print("TX",CENTER,2);
		//MojGLCD.printNumF(FTx,4,17,26);
		//MojGLCD.update();
		Izpisi = 2;
		
	}
	else
	{
		//MojGLCD.print("SB",CENTER,2);
		//MojGLCD.printNumF(FRx,4,17,26);
		//MojGLCD.update();
		Izpisi = 3;
	}
	
	if (Izpisi != OldIzpisi)
	{
		OldIzpisi = Izpisi;
		if (Izpisi == 1)
		{
			MojGLCD.print("RX",CENTER,2);
			MojGLCD.printNumF(FRx,4,17,26);
			//MojGLCD.update();
		}
		if (Izpisi == 2)
		{
			MojGLCD.print("TX",CENTER,2);
			MojGLCD.printNumF(FTx,4,17,26);
			//MojGLCD.update();
		}
		if (Izpisi == 3)
		{
			MojGLCD.print("SB",CENTER,2);
			MojGLCD.printNumF(FRx,4,17,26);
			//MojGLCD.update();
		}
		MojGLCD.update();
	}
/*	while (Serial.available() > 0)
	{
		char inChar = Serial.read();
		txtOdgovor += inChar;
		MojGLCD.print(txtOdgovor,CENTER,10);
		znaki++;
		if (znaki == 10)
		{
			txtOdgovor = "";
		}
		
	}*/
	
}
